package gregapi.load;

import static gregapi.data.CS.W;
import gregapi.data.MD;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.oredict.OreDictManager;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;


/**
 * @author Gregorius Techneticies
 */
public class LoaderUnificationTargets implements Runnable {
	@Override public String toString() {return "Unification Target Loader";}
	
	@Override
	public void run() {
		// Because most Mods (and vanilla MC) are not OreDict Compatible and need to be set as Target manually.
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Cu						, UT.Stacks.make(MD.GC, "item.basicItem", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Sn						, UT.Stacks.make(MD.GC, "item.basicItem", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Al						, UT.Stacks.make(MD.GC, "item.basicItem", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Steel					, UT.Stacks.make(MD.GC, "item.basicItem", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Bronze					, UT.Stacks.make(MD.GC, "item.basicItem", 1,10));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Fe						, UT.Stacks.make(MD.GC, "item.basicItem", 1,11));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.MeteoricIron			, UT.Stacks.make(MD.GC, "item.meteoricIronIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.MeteoricIron			, UT.Stacks.make(MD.GC, "item.meteoricIronIngot", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Desh					, UT.Stacks.make(MD.GC_PLANETS, "tile.mars", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Ti						, UT.Stacks.make(MD.GC_PLANETS, "item.itemBasicAsteroids", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Adamantite				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Co						, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Duralumin				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Pb						, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Mg						, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Mithril				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Ni						, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Oriharukon				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.Pt						, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.compressed		, MT.W						, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.CompressedPlates", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Pb						, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Adamantite				, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Co						, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Mg						, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Mithril				, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Ni						, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Oriharukon				, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Pt						, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.W						, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Duralumin				, UT.Stacks.make(MD.GC_GALAXYSPACE, "metalsblock", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Adamantite				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.Ingots", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Duralumin				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.Ingots", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Oriharukon				, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.Ingots", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.GlowstoneCeres			, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.GlowstoneDusts", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.GlowstoneIo			, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.GlowstoneDusts", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.GlowstoneEnceladus		, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.GlowstoneDusts", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.GlowstoneProteus		, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.GlowstoneDusts", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.GlowstonePluto			, UT.Stacks.make(MD.GC_GALAXYSPACE, "item.GlowstoneDusts", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gearGt			, MT.TitaniumAluminide		, UT.Stacks.make(MD.GC_ADV_ROCKETRY, "advancedRocketryproductgear", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gearGt			, MT.Iritanium				, UT.Stacks.make(MD.GC_ADV_ROCKETRY, "advancedRocketryproductgear", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.TitaniumAluminide		, UT.Stacks.make(MD.GC_ADV_ROCKETRY, "advancedRocketryproductsheet", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.Iritanium				, UT.Stacks.make(MD.GC_ADV_ROCKETRY, "advancedRocketryproductsheet", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.Fe						, UT.Stacks.make(MD.VULPES, "libVulpesproductsheet", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.Cu						, UT.Stacks.make(MD.VULPES, "libVulpesproductsheet", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.Steel					, UT.Stacks.make(MD.VULPES, "libVulpesproductsheet", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.Ti						, UT.Stacks.make(MD.VULPES, "libVulpesproductsheet", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.sheetGt		, MT.Al						, UT.Stacks.make(MD.VULPES, "libVulpesproductsheet", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.gearGt			, MT.Steel					, UT.Stacks.make(MD.VULPES, "libVulpesproductgear", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.gearGt			, MT.Ti						, UT.Stacks.make(MD.VULPES, "libVulpesproductgear", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Dilithium				, UT.Stacks.make(MD.VULPES, "libVulpesproductdust", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Dilithium				, UT.Stacks.make(MD.VULPES, "libVulpesproductcrystal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Manasteel				, UT.Stacks.make(MD.TCFM, "FMResource", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.ElvenElementium		, UT.Stacks.make(MD.TCFM, "FMResource", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.FierySteel				, UT.Stacks.make(MD.TF, "item.fieryIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Knightmetal			, UT.Stacks.make(MD.TF, "item.knightMetal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Steeleaf				, UT.Stacks.make(MD.TF, "item.steeleafIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.IronWood				, UT.Stacks.make(MD.TF, "item.ironwoodIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedAir				, UT.Stacks.make(MD.TC, "ItemShard", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedFire			, UT.Stacks.make(MD.TC, "ItemShard", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedWater			, UT.Stacks.make(MD.TC, "ItemShard", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEarth			, UT.Stacks.make(MD.TC, "ItemShard", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedOrder			, UT.Stacks.make(MD.TC, "ItemShard", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEntropy			, UT.Stacks.make(MD.TC, "ItemShard", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Hg						, UT.Stacks.make(MD.TC, "ItemNugget", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Thaumium				, UT.Stacks.make(MD.TC, "ItemNugget", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.VoidMetal				, UT.Stacks.make(MD.TC, "ItemNugget", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Thaumium				, UT.Stacks.make(MD.TC, "ItemResource", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.VoidMetal				, UT.Stacks.make(MD.TC, "ItemResource", 1,16));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Hg						, UT.Stacks.make(MD.TC, "ItemResource", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Amber					, UT.Stacks.make(MD.TC, "ItemResource", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Thaumium				, UT.Stacks.make(MD.TC, "blockCosmeticSolid", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Vinteum				, UT.Stacks.make(MD.ARS, "itemOre", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.ArcaneCompound			, UT.Stacks.make(MD.ARS, "itemOre", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.ArcaneAsh				, UT.Stacks.make(MD.ARS, "itemOre", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.VinteumPurified		, UT.Stacks.make(MD.ARS, "itemOre", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.UNUSED.Chimerite		, UT.Stacks.make(MD.ARS, "itemOre", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.BlueTopaz				, UT.Stacks.make(MD.ARS, "itemOre", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.UNUSED.Sunstone		, UT.Stacks.make(MD.ARS, "itemOre", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.UNUSED.Moonstone		, UT.Stacks.make(MD.ARS, "itemOre", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Manasteel				, UT.Stacks.make(MD.BOTA, "manaResource", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Terrasteel				, UT.Stacks.make(MD.BOTA, "manaResource", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.ElvenElementium		, UT.Stacks.make(MD.BOTA, "manaResource", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Manasteel				, UT.Stacks.make(MD.BOTA, "manaResource", 1,17));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Terrasteel				, UT.Stacks.make(MD.BOTA, "manaResource", 1,18));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.ElvenElementium		, UT.Stacks.make(MD.BOTA, "manaResource", 1,19));
//		OreDictManager.INSTANCE.setTarget(OP.dustTiny		, MT.Ag						, UT.Stacks.make(MD.WTCH, "ingredient", 1, 157)); may be unbalanced
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Chocolate				, UT.Stacks.make(MD.AA, "itemFood", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.BlackQuartz			, UT.Stacks.make(MD.AA, "itemDust", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.BlackQuartz			, UT.Stacks.make(MD.AA, "itemMisc", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Charcoal				, UT.Stacks.make(MD.AA, "blockMisc", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.CoalCoke				, UT.Stacks.make(MD.RC, "cube", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.CoalCoke				, UT.Stacks.make(MD.RC, "fuel.coke", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Firestone				, UT.Stacks.make(MD.RC, "firestone.raw", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Fe						, UT.Stacks.make(MD.RC, "part.plate", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Steel					, UT.Stacks.make(MD.RC, "part.plate", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.TinAlloy				, UT.Stacks.make(MD.RC, "part.plate", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Cu						, UT.Stacks.make(MD.RC, "part.plate", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Pb						, UT.Stacks.make(MD.RC, "part.plate", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Al						, UT.Stacks.make(MD.MaCu, "crafting", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Au						, UT.Stacks.make(MD.MaCu, "crafting", 1,13));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Ti						, UT.Stacks.make(MD.MaCu, "crafting", 1,17));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.WoodPolished			, UT.Stacks.make(MD.MaCu, "crafting", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.WoodPolished			, UT.Stacks.make(MD.MaCu, "woods", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.WoodSealed				, UT.Stacks.make(MD.IE, "material", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.WoodSealed				, UT.Stacks.make(MD.IE, "treatedWood", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.NetherQuartz			, UT.Stacks.make(MD.IE, "metal", 1, 18));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.ChargedCertusQuartz	, UT.Stacks.make(MD.AE, "item.ItemMultiMaterial", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Draconium				, UT.Stacks.make(MD.DE, "draconiumDust", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Draconium				, UT.Stacks.make(MD.DE, "nugget", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Draconium				, UT.Stacks.make(MD.DE, "draconiumIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Draconium				, UT.Stacks.make(MD.DE, "draconium", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.DraconiumAwakened		, UT.Stacks.make(MD.DE, "nugget", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.DraconiumAwakened		, UT.Stacks.make(MD.DE, "draconicIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.DraconiumAwakened		, UT.Stacks.make(MD.DE, "draconicBlock", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.H2SO4					, UT.Stacks.make(MD.FZ, "acid", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.AquaRegia				, UT.Stacks.make(MD.FZ, "acid", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.dustImpure		, MT.Netherrack				, UT.Stacks.make(MD.FZ, "nether_powder", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gemChipped		, MT.EnderPearl				, UT.Stacks.make(MD.RT, "ingredient", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Ectoplasm				, UT.Stacks.make(MD.RT, "ingredient", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.SpectreIron			, UT.Stacks.make(MD.RT, "ingredient", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.EnderiumBase			, UT.Stacks.make(MD.EIO, "itemPowderIngot", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.ElectricalSteel		, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.EnergeticAlloy			, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.VibrantAlloy			, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.RedstoneAlloy			, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.ConductiveIron			, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.PulsatingIron			, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.DarkSteel				, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Soularium				, UT.Stacks.make(MD.EIO, "itemAlloy", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.PulsatingIron			, UT.Stacks.make(MD.EIO, "itemMaterial", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.VibrantAlloy			, UT.Stacks.make(MD.EIO, "itemMaterial", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Stone					, UT.Stacks.make(MD.FMB, "stoneRod", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.Ash					, UT.Stacks.make(MD.BINNIE_BOTANY, "misc", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.Wood					, UT.Stacks.make(MD.BINNIE_BOTANY, "misc", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.S						, UT.Stacks.make(MD.BINNIE_BOTANY, "misc", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenCarbide		, UT.Stacks.make(MD.MgC, "item.ingotCarbide", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Yellorite				, UT.Stacks.make(MD.BR, "YelloriteOre", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Yellorium				, UT.Stacks.make(MD.BR, "BRMetalBlock", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Cyanite				, UT.Stacks.make(MD.BR, "BRMetalBlock", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Graphite				, UT.Stacks.make(MD.BR, "BRMetalBlock", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Blutonium				, UT.Stacks.make(MD.BR, "BRMetalBlock", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Ludicrite				, UT.Stacks.make(MD.BR, "BRMetalBlock", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Yellorium				, UT.Stacks.make(MD.BR, "BRIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Cyanite				, UT.Stacks.make(MD.BR, "BRIngot", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Graphite				, UT.Stacks.make(MD.BR, "BRIngot", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Blutonium				, UT.Stacks.make(MD.BR, "BRIngot", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Yellorium				, UT.Stacks.make(MD.BR, "BRIngot", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cyanite				, UT.Stacks.make(MD.BR, "BRIngot", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Graphite				, UT.Stacks.make(MD.BR, "BRIngot", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blutonium				, UT.Stacks.make(MD.BR, "BRIngot", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Ludicrite				, UT.Stacks.make(MD.BR, "BRIngot", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Ludicrite				, UT.Stacks.make(MD.BR, "BRIngot", 1, 9));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.HydrogenFluoride		, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 0));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.UraniumEnriched		, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 1));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.UraniumDepleted		, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 2));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Ammonium				, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 3));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Quicklime				, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.CaCO3					, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.OREMATS.Magnetite		, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Th						, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Emerald				, UT.Stacks.make(MD.ReC, "reactorcraft_item_raw", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Cd_In_Ag_Alloy			, UT.Stacks.make(MD.ReC, "reactorcraft_item_crafting", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.SteelMagnetic			, UT.Stacks.make(MD.ReC, "reactorcraft_item_crafting", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.SteelMagnetic			, UT.Stacks.make(MD.ReC, "reactorcraft_item_crafting", 1,10));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.U_238					, UT.Stacks.make(MD.ReC, "reactorcraft_item_crafting", 1,14));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenCarbide		, UT.Stacks.make(MD.ReC, "reactorcraft_item_crafting", 1,17));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Netherrack				, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 0));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Tar					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 1));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.SludgeOrganic			, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 2)); smelts into ethanol
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.Wood					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Bedrock				, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.NaCl					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 5));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.AmmoniumNitrate		, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 6)); Salt + Coal + Gunpowder + Redstone = 4 (180, 150, 200)
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.AgI					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 7));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Al						, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 8)); No Target needed
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.Wheat					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Coal					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1,10));
//		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.DryIce					, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1,11));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.InductiveAlloy			, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1,12));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Si						, UT.Stacks.make(MD.RoC, "rotarycraft_item_powders", 1,14));
//		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Ethanol				, UT.Stacks.make(MD.RoC, "rotarycraft_item_ethanol", 1, 0)); burns for 400 furnace time
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Anthracite				, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Prismane				, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lonsdaleite			, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Bedrock_HSLA_Alloy		, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenSintered		, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.InductiveAlloy			, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.CoalCoke				, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 8));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.SpringSteel			, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1, 9));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Si						, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1,10));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.AluminiumAlloy			, UT.Stacks.make(MD.RoC, "rotarycraft_item_compacts", 1,11));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.HSLA					, UT.Stacks.make(MD.RoC, "rotarycraft_item_shaftcraft", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.HSLA					, UT.Stacks.make(MD.RoC, "rotarycraft_item_shaftcraft", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.HSLA					, UT.Stacks.make(MD.RoC, "rotarycraft_item_shaftcraft", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.HSLA					, UT.Stacks.make(MD.RoC, "rotarycraft_block_deco", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Anthracite				, UT.Stacks.make(MD.RoC, "rotarycraft_block_deco", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Lonsdaleite			, UT.Stacks.make(MD.RoC, "rotarycraft_block_deco", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Bedrock_HSLA_Alloy		, UT.Stacks.make(MD.RoC, "rotarycraft_block_deco", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.CoalCoke				, UT.Stacks.make(MD.RoC, "rotarycraft_block_deco", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Stone					, UT.Stacks.make(MD.RoC, "rotarycraft_item_borecraft", 1, 13));
		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Diamond				, UT.Stacks.make(MD.RoC, "rotarycraft_item_borecraft", 1, 14));
//		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Livingwood				, UT.Stacks.make(MD.RoC, "rotarycraft_item_modinterface", 1, 17));
//		OreDictManager.INSTANCE.setTarget(OP.stickLong		, MT.Livingrock				, UT.Stacks.make(MD.RoC, "rotarycraft_item_modinterface", 1, 18));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Nutmeg					, UT.Stacks.make(MD.HaC, "groundnutmegItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cinnamon				, UT.Stacks.make(MD.HaC, "groundcinnamonItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cocoa					, UT.Stacks.make(MD.HaC, "cocoapowderItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Curry					, UT.Stacks.make(MD.HaC, "currypowderItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxPlant				, UT.Stacks.make(MD.HaC, "waxItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxBee					, UT.Stacks.make(MD.HaC, "beeswaxItem", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dustSmall		, MT.FishRaw				, UT.Stacks.make(MD.MaCu, "materials", 1, 14));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Wood					, UT.Stacks.make(MD.FR, "woodPulp", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxBee					, UT.Stacks.make(MD.FR, "beeswax", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxRefractory			, UT.Stacks.make(MD.FR, "refractoryWax", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Peat					, UT.Stacks.make(MD.FR, "peat", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingotDouble	, MT.PeatBituminous			, UT.Stacks.make(MD.FR, "bituminousPeat", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Pyrotheum				, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1,  512));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cryotheum				, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1,  513));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Aerotheum				, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1,  514));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Petrotheum				, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1,  515));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blizz					, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1, 1025));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blitz					, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1, 1027));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Basalz					, UT.Stacks.make(MD.TE_FOUNDATION, "material", 1, 1029));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lignite				, UT.Stacks.make(MD.UB, "ligniteCoal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.oreEndstone	, MT.EnderAmethyst			, UT.Stacks.make(MD.BoP, "gemOre", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.EnderAmethyst			, UT.Stacks.make(MD.BoP, "gemOre", 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderAmethyst			, UT.Stacks.make(MD.BoP, "gems", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Coffee					, UT.Stacks.makeIC2("coffeePowder", 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.HydratedCoal			, UT.Stacks.makeIC2("hydratedCoalDust", 1));
		OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Creosote				, UT.Stacks.make(MD.RC, "fluid.creosote.cell", 1));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Empty					, UT.Stacks.make(Items.glass_bottle, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Water					, UT.Stacks.make(Items.potionitem, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Coal					, UT.Stacks.make(Blocks.coal_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Fe						, UT.Stacks.make(Blocks.iron_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Lapis					, UT.Stacks.make(Blocks.lapis_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone				, UT.Stacks.make(Blocks.redstone_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone				, UT.Stacks.make(Blocks.lit_redstone_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Au						, UT.Stacks.make(Blocks.gold_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Diamond				, UT.Stacks.make(Blocks.diamond_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Emerald				, UT.Stacks.make(Blocks.emerald_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ore			, MT.NetherQuartz			, UT.Stacks.make(Blocks.quartz_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lapis					, UT.Stacks.make(Items.dye, 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderEye				, UT.Stacks.make(Items.ender_eye, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderPearl				, UT.Stacks.make(Items.ender_pearl, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Diamond				, UT.Stacks.make(Items.diamond, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Emerald				, UT.Stacks.make(Items.emerald, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Coal					, UT.Stacks.make(Items.coal, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Charcoal				, UT.Stacks.make(Items.coal, 1, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherQuartz			, UT.Stacks.make(Items.quartz, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherStar				, UT.Stacks.make(Items.nether_star, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Au						, UT.Stacks.make(Items.gold_nugget, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Au						, UT.Stacks.make(Items.gold_ingot, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Fe						, UT.Stacks.make(Items.iron_ingot, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Paper					, UT.Stacks.make(Items.paper, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Sugar					, UT.Stacks.make(Items.sugar, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Bone					, UT.Stacks.make(Items.dye, 1, 15));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Redstone				, UT.Stacks.make(Items.redstone, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Gunpowder				, UT.Stacks.make(Items.gunpowder, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Glowstone				, UT.Stacks.make(Items.glowstone_dust, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blaze					, UT.Stacks.make(Items.blaze_powder, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Blaze					, UT.Stacks.make(Items.blaze_rod, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Wood					, UT.Stacks.make(Items.stick, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Fe						, UT.Stacks.make(Blocks.iron_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Au						, UT.Stacks.make(Blocks.gold_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Diamond				, UT.Stacks.make(Blocks.diamond_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Emerald				, UT.Stacks.make(Blocks.emerald_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Lapis					, UT.Stacks.make(Blocks.lapis_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Coal					, UT.Stacks.make(Blocks.coal_block, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockDust		, MT.Redstone				, UT.Stacks.make(Blocks.redstone_block, 1, 0));
		if (MD.IC2C.mLoaded) {
		OreDictManager.INSTANCE.setTarget(OP.plateDense		, MT.Cu						, UT.Stacks.make(MD.IC2, "item.itemPartDCP", 1, 0));
		} else {
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Fe						, UT.Stacks.makeIC2("casingiron", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Au						, UT.Stacks.makeIC2("casinggold", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Cu						, UT.Stacks.makeIC2("casingcopper", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Sn						, UT.Stacks.makeIC2("casingtin", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Pb						, UT.Stacks.makeIC2("casinglead", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Bronze					, UT.Stacks.makeIC2("casingbronze", 1));
		OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Steel					, UT.Stacks.makeIC2("casingadviron", 1));
		}
		OM.blacklist(UT.Stacks.make(MD.TC, "ItemResource", 1,18));
		OM.blacklist(UT.Stacks.make(MD.FZ, "diamond_shard", 1, W));
	}
}